"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const context_1 = __importDefault(require("../../context"));
const error_1 = require("../error");
const useFeature = (featureReadableId) => {
    const hash = react_1.useRef(`${Math.random()}`);
    const engine = react_1.useContext(context_1.default);
    react_1.useEffect(() => {
        const currentHash = hash.current;
        return () => {
            try {
                if (engine) {
                    engine.unregisterCaller(currentHash);
                }
            }
            catch (_a) { }
        };
    }, [engine]);
    try {
        if (engine) {
            const { isActive, givenValue, metaData } = engine.getFeature(featureReadableId, hash.current);
            return [isActive, givenValue, metaData];
        }
        console.error(error_1.providerError('useFeature'));
    }
    catch (_a) { }
    return [false, undefined, { isDataLoaded: false }];
};
exports.default = useFeature;
//# sourceMappingURL=index.js.map