"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const context_1 = __importDefault(require("./context"));
const Provider = ({ children, engine: engineProp }) => {
    const engineListenerId = react_1.useRef();
    const [engine, setEngine] = react_1.useState(engineProp);
    const handleEngineUpdate = react_1.useCallback((newEngine) => {
        setEngine(newEngine);
    }, []);
    react_1.useEffect(() => {
        if (!engineListenerId.current) {
            engineListenerId.current = engine.addEngineListener(handleEngineUpdate);
        }
        return () => {
            if (engineListenerId.current) {
                engine.removeEngineListener(engineListenerId.current);
            }
        };
    }, [engine, handleEngineUpdate]);
    return react_1.default.createElement(context_1.default.Provider, { value: engine }, children);
};
exports.default = Provider;
//# sourceMappingURL=provider.js.map